
#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <time.h>

#include <assert.h>

#include "histo.h"

#include "local_time.h"

void *create_new_elem_hist (char *url, char *ipcli, int staterr) {
    struct elem_hist *elem = NULL;
    if ((elem = calloc (1, sizeof (struct elem_hist))) == NULL) {
        perror ("calloc");
        return NULL;
    }
    if ((elem->q_url = calloc (strlen (url) +1, sizeof (char))) == NULL) {
        perror ("calloc");
        return NULL;
    }
    strcpy (elem -> q_url, url);
    if ((elem->q_ipcli = calloc (strlen (ipcli) +1, sizeof (char))) == NULL) {
        perror ("calloc");
        return NULL;
    }
    strcpy (elem -> q_ipcli, ipcli);
    elem->q_staterr = staterr;
    if (get_local_time (&(elem->q_date), 0) == -1) {
        fprintf (stderr, "L'appel à get_local_time a échoué.\n");
        return NULL;
    }
    elem->q_next = NULL;
    return (void *) elem;
}

void delete_elem_hist (void *q_elem) {
    struct elem_hist *tmp_elem = (struct elem_hist *) q_elem;
    free (tmp_elem -> q_url);
    free (tmp_elem -> q_ipcli);
    free (tmp_elem -> q_date);
    free (q_elem);
    tmp_elem->q_next = NULL;
    tmp_elem = NULL;
}

void *new_queue (long  (*get_size_queue) (void *), long  (*get_max_size_queue) (void *), int (*push) (void *, void *), int (*pop) (void *), void * (*get_elem) (void *, int), int (*get_nb_elem) (void *), long  (*get_size_elem) (void *), long  max_size_queue) {
    struct queue_hist *queue = NULL;
    if ((queue = calloc (1, sizeof (struct queue_hist))) == NULL) {
        perror ("calloc");
        return NULL;
    }
    queue->nb_elem = 0;
    queue->size_queue = 0;
    queue->max_size_queue = max_size_queue;
    queue->first_elem = NULL;
    queue->last_elem = NULL;
    queue->get_size_queue = get_size_queue;
    queue->get_max_size_queue = get_max_size_queue;
    queue->push = push;
    queue->pop = pop;
    queue->get_elem = get_elem;
    queue->get_nb_elem = get_nb_elem;
    queue->get_size_elem = get_size_elem;
    return (void *) queue;
}

void delete_queue (void *q_this) {
    int nb_elem = ((struct queue_hist *) q_this)->nb_elem;
    for (int i = 0; i < nb_elem; i++) {
        ((struct queue_hist *) q_this)->pop (q_this);
    }
    ((struct queue_hist *) q_this)->first_elem = NULL;
    ((struct queue_hist *) q_this)->last_elem = NULL;
    free (q_this);
}

long  get_size_queue (void *q_this) {
    if (q_this != NULL)
        return ((struct queue_hist *) q_this)->size_queue;
    return -1;
}

long  get_max_size_queue (void *q_this) {
    if (q_this != NULL)
        return ((struct queue_hist *) q_this)->max_size_queue;
    return -1;
}

int push (void *q_this, void *q_elem) {
    int size_elem = 0;
    void *q_elem_tmp = NULL;
    if ((q_this != NULL) && (q_elem != NULL)) {
        size_elem = get_size_elem (q_elem);
        while ((((struct queue_hist *) q_this)->get_size_queue (q_this) + size_elem) > ((struct queue_hist *) q_this)->get_max_size_queue (q_this)) {
            fprintf (stdout, "\n\nTaille trop petite\n\n");
            ((struct queue_hist *) q_this)->pop (q_this);
        }
        ((struct queue_hist *) q_this)->nb_elem++;
        ((struct queue_hist *) q_this)->size_queue += size_elem;
        if ((((struct queue_hist *) q_this)->first_elem == NULL) && (((struct queue_hist *) q_this)->last_elem == NULL)) {
            ((struct queue_hist *) q_this)->first_elem = q_elem;
            ((struct queue_hist *) q_this)->last_elem = q_elem;
        }
        else {
            q_elem_tmp = ((struct queue_hist *) q_this)->last_elem;
            ((struct queue_hist *) q_this)->last_elem = q_elem;
            ((struct elem_hist *) q_elem)->q_next = q_elem_tmp;
        }
        return EXIT_SUCCESS;
    }
    return -1;
}

int pop (void *q_this) {
    int size_first_elem = 0;
    void *q_elem_tmp = NULL;
    void *q_elem_last_tmp = NULL;
    if (q_this != NULL) {
        size_first_elem = ((struct queue_hist *) q_this)->get_size_elem (((struct queue_hist *) q_this)->first_elem);
        if (((struct queue_hist *) q_this)->nb_elem < 1) {
            return -1;
        }
        else if (((struct queue_hist *) q_this)->nb_elem == 1) {
            q_elem_tmp = ((struct queue_hist *) q_this)->first_elem;
            ((struct queue_hist *) q_this)->first_elem = NULL;
            ((struct queue_hist *) q_this)->last_elem = NULL;
        }
        else if (((struct queue_hist *) q_this)->nb_elem > 1) {
            q_elem_last_tmp = ((struct queue_hist *) q_this)->last_elem;
            q_elem_tmp = ((struct queue_hist *) q_this)->first_elem;
            for (int i = 0; i < (((struct queue_hist *) q_this)->nb_elem - 2); i++) {
                q_elem_last_tmp = ((struct elem_hist *) q_elem_last_tmp)->q_next;
            }
            ((struct elem_hist *) q_elem_last_tmp)->q_next = NULL;
            ((struct queue_hist *) q_this)->first_elem = q_elem_last_tmp;
        }
        ((struct queue_hist *) q_this)->nb_elem--;
        ((struct queue_hist *) q_this)->size_queue -= size_first_elem;
        delete_elem_hist (q_elem_tmp);
        return EXIT_SUCCESS;
    }
    return -1;
}

void *get_elem (void *q_this, int index) {
    struct queue_hist *q = (struct queue_hist *) q_this;
    struct elem_hist *e = (struct elem_hist *) (q->last_elem);
    for (int i = 0; i < index; i++) {
        e = (struct elem_hist *) (((struct elem_hist *) e)->q_next);
    }
    return (void *) e;
}

int get_nb_elem (void *q_this) {
    if (q_this != NULL)
        return ((struct queue_hist *) q_this)->nb_elem;
    return -1;
}

long  get_size_elem (void *q_elem) {
    long  size_elem = 0;
    if (q_elem != NULL) {
        if (((struct elem_hist *) q_elem)->q_url != NULL) {
            for (int i = 0; ((struct elem_hist *) q_elem)->q_url[i] != 0; i++)
                size_elem += sizeof (char);
            size_elem += sizeof (char);
        }
        if (((struct elem_hist *) q_elem)->q_ipcli != NULL) {
            for (int i = 0; ((struct elem_hist *) q_elem)->q_ipcli[i] != 0; i++)
                size_elem += sizeof (char);
            size_elem += sizeof (char);
        }
        if (((struct elem_hist *) q_elem)->q_date != NULL) {
            for (int i = 0; ((struct elem_hist *) q_elem)->q_date[i] != 0; i++)
                size_elem += sizeof (char);
            size_elem += sizeof (char);
        }
        size_elem += sizeof (int);
        size_elem += sizeof (void *);
        return size_elem;
    }
    return -1;
}

void print_queue (void *q_this) {
    struct queue_hist *q = (struct queue_hist *) q_this;
    struct elem_hist *e = (struct elem_hist *) (q->last_elem);
    fprintf (stdout, "\nprint queue @ = %p\n-----------\n", q_this);
    for (int i = 0; i < q->get_nb_elem (q_this); i++) {
        print_elem ((void *) e);
        e = (struct elem_hist *) (((struct elem_hist *) e)->q_next);
    }
}

void print_elem (void *q_elem) {
    struct elem_hist *e = (struct elem_hist *) q_elem;
    fprintf (stdout, "@@@@@\nsizeof() = %ld [o]\n", get_size_elem (q_elem));
    fprintf (stdout, "+++++\nadr : %p\n+++++\nurl : %s\nipcli : %s\ndate : %s\nstaterr : %d\nq_next : %p\n@@@@@\n", (void *) e, e -> q_url, e -> q_ipcli, e -> q_date, e -> q_staterr, (void *) (e -> q_next));
}

int rand_x_y (int x, int y) {
    return (rand () % (y - x) + x);
}

int get_file_name (char **buffer) {
    char *buffer_tmp = NULL;
    char srval [5] = {0, 0, 0, 0, 0};
    int rval = 0;
    int size = 0;
    srand (time (NULL));
    rval = rand_x_y (1000, 9999);
    sprintf (srval, "%d", rval);
    size = get_local_time (&buffer_tmp, 0);
    assert (* buffer == NULL);
    if ((*buffer = calloc (size +1 + 4, sizeof (char))) == NULL) {
        perror ("calloc");
        return -1;
    }
    strcpy (* buffer, buffer_tmp);
    strcat (* buffer, srval);
    return (size + 4);
}

