
#include <stdio.h>

#include <stdlib.h>

#include <unistd.h>

#include <string.h>

#include <errno.h>

#include <arpa/inet.h>

#include <netdb.h>

#include <netinet/in.h>

#include <sys/types.h>

#include <sys/socket.h>

#include "socket.h"

#include "process_management.h"

#include "server_const.h"

struct server_process *init_server_process (int (*ptr_child_process) (void *), int (*ptr_father_process) (void *), int *sock) {
    struct server_process *psp;
    if ((psp = calloc (1, sizeof (struct server_process))) == NULL) {
        perror ("calloc");
        return NULL;
    }
    psp->ptr_process[0] = ptr_child_process;
    psp->ptr_process[1] = ptr_father_process;
    psp->data = (void *) sock;
    return psp;
}

void delete_server_process (struct server_process *ptr_sp) {
    free (ptr_sp);
}

int call_fork (int val, struct server_process *ptr_sp) {
    if (val < 0)
        return -1;
    (*ptr_sp->ptr_process[((!val) ? 0 : 1)]) ((void *) ptr_sp->data);
    return EXIT_SUCCESS;
}

int ipv4_process (void *data) {
    struct sockaddr_in addr;
    socklen_t len;
    struct server_process *psp;
    int sock_connected;
    int *sock_name = (int *) data;
    int **sock_process = calloc (2, sizeof (int *));
    sock_process[0] = &sock_name[0];
    sock_process[1] = &sock_connected;
    psp = init_server_process (child_process, father_process, (void *) sock_process);
    listen (sock_name [0], TAILLE_FILE_ECOUTE);
    fprintf (stdout, "Mon adresse >> ");
    if ((print_socket_address (sock_name[0], LOCAL, NULL)) < 0) {
        fprintf (stderr, "L'appel à print_socket_address a échoué.\n");
        return -1;
    }
    while (!close_tcp_server ()) {
        len = sizeof (struct sockaddr_in);
        if ((sock_connected = accept (sock_name[0], (struct sockaddr *) &addr, &len)) < 0) {
            perror ("accept");
            return -1;
        }
        call_fork (fork (), psp);
    }
    delete_server_process (psp);
    close (sock_name [0]);
    return EXIT_SUCCESS;
}

int ipv6_process (void *data) {
    struct sockaddr_in addr;
    socklen_t len;
    struct server_process *psp;
    int sock_connected;
    int *sock_name = (int *) data;
    int **sock_process = calloc (2, sizeof (int *));
    sock_process[0] = &sock_name[1];
    sock_process[1] = &sock_connected;
    psp = init_server_process (child_process, father_process, (void *) sock_process);
    listen (sock_name [1], TAILLE_FILE_ECOUTE);
    fprintf (stdout, "Mon adresse >> ");
    if ((print_socket_address (sock_name[1], LOCAL, NULL)) < 0) {
        fprintf (stderr, "L'appel à print_socket_address a échoué.\n");
        return -1;
    }
    while (!close_tcp_server ()) {
        len = sizeof (struct sockaddr_in);
        if ((sock_connected = accept (sock_name[1], (struct sockaddr *) &addr, &len)) < 0) {
            perror ("accept");
            return -1;
        }
        call_fork (fork (), psp);
    }
    delete_server_process (psp);
    close (sock_name [1]);
    return EXIT_SUCCESS;
}

int child_process (void *data) {
    int **sock = (int **) data;
    close (* (sock [0]));
    process_connection (* (sock [1]));
    exit (EXIT_SUCCESS);
}

int father_process (void *data) {
    int **sock = (int **) data;
    close (* (sock [1]));
    return EXIT_SUCCESS;
}

